package network;

import structure.*;
import java.util.*;

public class LinkStateMessage implements StructuredObject
{
  public LinkStateMessage ()
  {
  }
  
  public int seqNum;
  public String sourceName;
  public Vector links;
  
  public String toString ()
  {
    String retval = "" + "From: '" + sourceName + "' " + seqNum + "\n";
    if (links != null)
      {
	Enumeration e = links.elements ();
	while (e.hasMoreElements ())
	  {
            LinkStateItem item = (LinkStateItem) e.nextElement ();
            retval = retval + "   -> '" + item.destName + 
	      "'  (" + item.bandwidth + " Mb/s)\n";
	  }
      }
    
    return retval;
  }
  
  public void FoldInStructure (StructuredStorage s)
  {
    seqNum = s.GetInt ("seqNum");
    sourceName = s.GetString ("sourceName");
    links = s.GetVector ("links");
  }
  
  public void FoldOutStructure (StructuredStorage s)
  {
    s.SetInt ("seqNum", seqNum);
    s.SetString ("sourceName", sourceName);
    s.SetVector ("links", links);
  }
}

